#ifndef URDUSORTING_H
#define URDUSORTING_H

#include <vector>
#include <algorithm>
using namespace std;

#include "FileReader.h"
#include "FileWriter.h"

	struct CCode
	{
		int charCode;
		int collationCode[3];
	};

	struct Code
	{
		vector<CCode> CElement;
	};
	

	class UrduSorting
	{
		private:
			int MaxUrduCode;//Extended Arabic digit nine
			int MinUrduCode;//Arabic number sign
			CCode NonJoiner;
			int currentPos;
			int size,collationTableSize;
			wstring cword;
						
			bool NormalizeArray[0x06FA-0x0600];///MaxUrduCode- MinUrduCode
			Code * CollationElement;  //[size of Collation table ] 
			int CollationElementIndex [0x06FA-0x0600 ];//MaxUrduCode- MinUrduCode
			int Hex2Dec(string hex);
			
			unsigned int GetCharacterCode(string hexstr);
			void GetCollationCode(string hexstr,int CollationCode[],int levels);
			void Normalize(wstring word);
			bool GetCharCollationCode(int CollationCode[],int levels);
			bool LoadCollationTable(string srfile);
		
			
		public: 
			UrduSorting();
			~UrduSorting();

			bool Initialize(string srfile);
			void Terminate();

					
			int Compare(wstring source, wstring target, int strength);
			string GetCollationKey(wstring str, int strength);
		
		
	};
#endif
